/*************************************************************************************************
 * relic.o
 * QDBMNDBMߴAPI
 *                                                       Copyright(c) 2000-2003 Mikio Hirabayashi
 * 
 *    APIǤDepotΥ֤ǤꡢNDBMθߴ󥿥եǤ롣
 *    Ͻϰ¸POSIXXPGUNIXɸˤʤ٤碌褦ˤƤ롣
 *
 * Ūջ
 *    Ρ֥ȡפȤѸϡmalloc/calloc/realloc ΰݤ뤳Ȥ̣
 *      Ƥ롣ͤȤƥȤ줿ΰΥݥ󥿤֤ؿ¿뤬ΰ
 *      ǤϸƤӽФ¦餦Ȥˤʤ롣
 *    åɥդǤϤʤꥨȥȤǤʤ
 *    intХȤ򲼲ϤǤưʤ
 *************************************************************************************************/


/* Ƚ */
#ifndef _RELIC_H
#define _RELIC_H


#include <depot.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>



/*************************************************************************************************
 * API
 *  ǡ١Ѥ뤿ˤϡdbm_open ǥǡ١ե򳫤ͤǤDBM
 *    Υݥ󥿤ϥɥȤѤ롣
 *  ǡ١Ѥ顢ɬ dbm_close Ĥ٤Ǥ롣
 *  饤ɤ߽ξѥ⡼ɡˤǥǡ١ե򳫤ݤˤϤΥǥ쥯ȥФ¾
 *    å졢꡼ɤ߹ѥ⡼ɡˤǳݤˤ϶ͭå롣κݤ
 *    ϳΥåޤǥ֥å롣
 *  DBM¤ΤΥФľܻȤ뤳ȤϿ侩ʤ
 *************************************************************************************************/


typedef struct {                         /* ǡ١ϥɥι¤η */
  DEPOT *depot;                          /* ǡ١ϥɥ */
  int dfd;                               /* ߡեΥǥץ */
  char *dbm_fetch_vbuf;                  /* dbm_fetchͤΥХåե */
  char *dbm_nextkey_kbuf;                /* dbm_nextkeyͤΥХåե */
} DBM;

typedef struct {                         /* ͤι¤η */
  void *dptr;                            /* ǡΰؤΥݥ */
  size_t dsize;                          /* ǡΰΥ */
} datum;

enum {                                   /* ʣ񤭹 */
  DBM_INSERT,                            /* 񤭤 */
  DBM_REPLACE                            /* ¸ͤݻ */
};


/* ǡ١ե򳫤Υϥɥ֤
   name ϥǡ١̾ꤹ뤬ե̾ϤĤΤˤʤ롣
   flags  open ϤΤƱO_WRONLY  O_RDWR Ʊˤʤꡢ
   ɲåե饰Ǥ O_CREAT  O_TRUNC ΤߤͭǤ롣
   mode  open ϤΤƱǥեΥ⡼ɤꤹ롣
   ͤʤǡ١ϥɥǤꡢ顼ʤ NULL Ǥ롣 */
DBM *dbm_open(char *name, int flags, int mode);


/* ǡ١եĤ롣
   db ϥǡ١ϥɥꤹ롣
   ĤϥɥΰϲΤǡʸѤ뤳ȤǤʤʤ롣 */
void dbm_close(DBM *db);


/* ǡ١˥쥳ɤɲä롣
   db ϥǡ١ϥɥꤹ롣
   key ϥι¤Τꤹ롣
   content ͤι¤Τꤹ롣
   frags  DBM_INSERT ʤ饭νʣ˽񤭹ߤǰDBM_REPLACE ʤ񤭤Ԥ
   ͤʤ 0 ǤꡢʣǤǰʤ 1 Ǥꡢ¾Υ顼ʤ -1 Ǥ롣 */
int dbm_store(DBM *db, datum key, datum content, int flags);


/* ǡ١쥳ɤ롣
   db ϥǡ١ϥɥꤹ롣
   key ϥι¤Τꤹ롣
   ͤʤ 0 Ǥꡢ顼ʤ -1 Ǥ롣 */   
int dbm_delete(DBM *db, datum key);


/* ǡ١쥳ɤͤФ롣
   db ϥǡ١ϥɥꤹ롣
   key ϥι¤Τꤹ롣
   ͤͤι¤ΤǤ롣Х dptr ΰؤdsize 򼨤
   ʤ dptr  NULL Ȥʤ롣
   dptr λؤΰϥϥɥ˴ϢŤƳݤ졢ƱϥɥФƼˤδؿƤӽ
   ϥɥĤޤǡͭʥǡݻ롣
   ͤΰΣХȸˤϽüʸ֤ΤǡʸȤѤǤ롣 */
datum dbm_fetch(DBM *db, datum key);


/* ǡ١Υƥ졼ǽΥФ
   db ϥǡ١ϥɥꤹ롣
   ͤͤι¤ΤǤ롣Х dptr ΰؤdsize 򼨤
   ʤ dptr  NULL Ȥʤ롣
   dptr λؤΰϥϥɥ˴ϢŤƳݤ졢ƱϥɥФƼˤδؿƤӽ
   ϥɥĤޤǡͭʥǡݻ롣
   ͤΰΣХȸˤϽüʸ֤ΤǡʸȤѤǤ롣 */
datum dbm_firstkey(DBM *db);


/* ǡ١Υƥ졼鼡ΥФ
   db ϥǡ١ϥɥꤹ롣
   ͤͤι¤ΤǤ롣Х dptr ΰؤdsize 򼨤
   ʤ dptr  NULL Ȥʤ롣
   dptr λؤΰϥϥɥ˴ϢŤƳݤ졢ƱϥɥФƼˤδؿƤӽ
   ϥɥĤޤǡͭʥǡݻ롣
   ͤΰΣХȸˤϽüʸ֤ΤǡʸȤѤǤ롣 */
datum dbm_nextkey(DBM *db);


/* ⤷ʤ
   db ϥǡ١ϥɥꤹ롣
   ͤ 0 Ǥ롣
   δؿϸߴΤˤΤ¸ߤ롣 */
int dbm_error(DBM *db);


/* ⤷ʤ
   db ϥǡ١ϥɥꤹ롣
   ͤ 0 Ǥ롣
   δؿϸߴΤˤΤ¸ߤ롣 */
int dbm_clearerr(DBM *db);


/* ǡ١ɤ߹Ѥɤ֤
   db ϥǡ١ϥɥꤹ롣
   ͤɤ߹Ѥʤ鿿ǤʤеǤ롣 */
int dbm_rdonly(DBM *db);


/* ǥ쥯ȥեΥեǥץ֤
   db ϥǡ١ϥɥꤹ롣
   ͤϥǥ쥯ȥեΥեǥץǤ롣 */
int dbm_dirfno(DBM *db);


/* ǡեΥեǥץ֤
   db ϥǡ١ϥɥꤹ롣
   ͤϥǡեΥեǥץǤ롣 */
int dbm_pagfno(DBM *db);



#endif /* Ƚ꽪λ */


/* END OF FILE */
